package dev.peerat.parser.java.operation;

import java.util.List;

import dev.peerat.parser.Token;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.java.visitor.JavaVisitor;
import dev.peerat.parser.visitor.Visitor;
import dev.peerat.parser.visitor.VisitorBag;

public class CatchOperation extends OperationBag{
	
	private List<Token> types;
	private Token name;
	
	public CatchOperation(List<Token> types, Token name){
		super();
		this.types = types;
		this.name = name;
	}
	
	public List<Token> getTypes(){
		return this.types;
	}
	
	public Token getName(){
		return this.name;
	}

	@Override
	public VisitorBag visit(Visitor<JavaElement> visitor) {
		if(visitor.canVisit(getClass())) return visitor.visit(this);
		return super.visit(visitor);
	}

}
