package dev.peerat.parser.tree;

import java.util.HashMap;
import java.util.Map;

import dev.peerat.parser.state.StateTree;

public class SyntaxTreeRegistery<E>{
	
	private Map<Class<?>, SyntaxTree<E>> registery;

	public SyntaxTreeRegistery(){
		this.registery = new HashMap<>();
	}
	
	public void register(SyntaxTree<E> node){
		this.registery.put(node.getClass(), node);
	}
	
	public StateTree<E> getNode(Class<?> clazz){
		return this.registery.get(clazz).getNode();
	}
	
	public <T extends SyntaxTree<E>> T getTree(Class<?> clazz){
		T result = (T) this.registery.get(clazz);
		result.checkInit();
		return result;
	}
	
	public void init(){
		for(SyntaxTree<E> tree : registery.values()){
			tree.checkInit();
		}
	}
}
