package dev.peerat.parser.visitor;

import java.util.Collection;

import dev.peerat.parser.Token;

public abstract class Visitor<T>{
	
	public static Visitor<Token> allToken(){
		return new TokenVisitor(true);
	}
	
	public static Visitor<Token> token(){
		return new TokenVisitor(false);
	}
	
	public abstract boolean canVisit(Class<?> type); //TODO change "Class<?> type" into "Object element" ?
	
	public abstract boolean canPropagate();
	
	public abstract VisitorBag visit(T element);
	
	protected <E> boolean validates(VisitorBag bag, Collection<? extends E> list, Visitor<E> visitor){
		boolean validateOne = false;
		for(E element : list){
			VisitorBag result = visitor.visit(element);
			if(result.isValidated()){
				validateOne = true;
				bag.merge(result);
			}
		}
		return validateOne;
	}
}
